=== removed file 'drizzled/function/str/hex.cc'
--- drizzled/function/str/hex.cc	2010-02-04 08:14:46 +0000
+++ drizzled/function/str/hex.cc	1970-01-01 00:00:00 +0000
@@ -1,127 +0,0 @@
-/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
- *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
- *
- *  Copyright (C) 2008 Sun Microsystems
- *
- *  This program is free software; you can redistribute it and/or modify
- *  it under the terms of the GNU General Public License as published by
- *  the Free Software Foundation; version 2 of the License.
- *
- *  This program is distributed in the hope that it will be useful,
- *  but WITHOUT ANY WARRANTY; without even the implied warranty of
- *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *  GNU General Public License for more details.
- *
- *  You should have received a copy of the GNU General Public License
- *  along with this program; if not, write to the Free Software
- *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
- */
-
-#include "config.h"
-#include <drizzled/util/convert.h>
-#include <drizzled/function/str/hex.h>
-#include "drizzled/internal/m_string.h"
-
-namespace drizzled
-{
-
-/**
-  convert a hex digit into number.
-*/
-static int hexchar_to_int(char c)
-{
-  if (c <= '9' && c >= '0')
-    return c-'0';
-  c|=32;
-  if (c <= 'f' && c >= 'a')
-    return c-'a'+10;
-  return -1;
-}
-
-String *Item_func_hex::val_str(String *str)
-{
-  String *res;
-  assert(fixed == 1);
-  if (args[0]->result_type() != STRING_RESULT)
-  {
-    uint64_t dec;
-    char ans[65],*ptr;
-    /* Return hex of unsigned int64_t value */
-    if (args[0]->result_type() == REAL_RESULT ||
-        args[0]->result_type() == DECIMAL_RESULT)
-    {
-      double val= args[0]->val_real();
-      if ((val <= (double) INT64_MIN) ||
-          (val >= (double) (uint64_t) UINT64_MAX))
-        dec=  ~(int64_t) 0;
-      else
-        dec= (uint64_t) (val + (val > 0 ? 0.5 : -0.5));
-    }
-    else
-      dec= (uint64_t) args[0]->val_int();
-
-    if ((null_value= args[0]->null_value))
-      return 0;
-    ptr= internal::int64_t2str(dec,ans,16);
-    if (str->copy(ans,(uint32_t) (ptr-ans),default_charset()))
-      return &my_empty_string;			// End of memory
-    return str;
-  }
-
-  /* Convert given string to a hex string, character by character */
-  res= args[0]->val_str(str);
-  if (!res || tmp_value.alloc(res->length()*2+1))
-  {
-    null_value=1;
-    return 0;
-  }
-  null_value=0;
-  tmp_value.length(res->length()*2);
-
-  (void) drizzled_string_to_hex((char*) tmp_value.ptr(), res->ptr(),
-                                res->length());
-  return &tmp_value;
-}
-
-  /** Convert given hex string to a binary string. */
-
-String *Item_func_unhex::val_str(String *str)
-{
-  const char *from, *end;
-  char *to;
-  String *res;
-  uint32_t length;
-  assert(fixed == 1);
-
-  res= args[0]->val_str(str);
-  if (!res || tmp_value.alloc(length= (1+res->length())/2))
-  {
-    null_value=1;
-    return 0;
-  }
-
-  from= res->ptr();
-  null_value= 0;
-  tmp_value.length(length);
-  to= (char*) tmp_value.ptr();
-  if (res->length() % 2)
-  {
-    int hex_char;
-    *to++= hex_char= hexchar_to_int(*from++);
-    if ((null_value= (hex_char == -1)))
-      return 0;
-  }
-  for (end=res->ptr()+res->length(); from < end ; from+=2, to++)
-  {
-    int hex_char;
-    *to= (hex_char= hexchar_to_int(from[0])) << 4;
-    if ((null_value= (hex_char == -1)))
-      return 0;
-    *to|= hex_char= hexchar_to_int(from[1]);
-    if ((null_value= (hex_char == -1)))
-      return 0;
-  }
-  return &tmp_value;
-}
-
-} /* namespace drizzled */

=== removed file 'drizzled/function/str/hex.h'
--- drizzled/function/str/hex.h	2010-02-04 08:14:46 +0000
+++ drizzled/function/str/hex.h	1970-01-01 00:00:00 +0000
@@ -1,64 +0,0 @@
-/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
- *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
- *
- *  Copyright (C) 2008 Sun Microsystems
- *
- *  This program is free software; you can redistribute it and/or modify
- *  it under the terms of the GNU General Public License as published by
- *  the Free Software Foundation; version 2 of the License.
- *
- *  This program is distributed in the hope that it will be useful,
- *  but WITHOUT ANY WARRANTY; without even the implied warranty of
- *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *  GNU General Public License for more details.
- *
- *  You should have received a copy of the GNU General Public License
- *  along with this program; if not, write to the Free Software
- *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
- */
-
-#ifndef DRIZZLED_FUNCTION_STR_HEX_H
-#define DRIZZLED_FUNCTION_STR_HEX_H
-
-#include <drizzled/function/str/strfunc.h>
-
-namespace drizzled
-{
-
-class Item_func_hex :public Item_str_func
-{
-  String tmp_value;
-public:
-  Item_func_hex(Item *a) :Item_str_func(a) {}
-  const char *func_name() const { return "hex"; }
-  String *val_str(String *);
-  void fix_length_and_dec()
-  {
-    collation.set(default_charset());
-    decimals=0;
-    max_length=args[0]->max_length*2*collation.collation->mbmaxlen;
-  }
-};
-
-class Item_func_unhex :public Item_str_func
-{
-  String tmp_value;
-public:
-  Item_func_unhex(Item *a) :Item_str_func(a)
-  {
-    /* there can be bad hex strings */
-    maybe_null= 1;
-  }
-  const char *func_name() const { return "unhex"; }
-  String *val_str(String *);
-  void fix_length_and_dec()
-  {
-    collation.set(&my_charset_bin);
-    decimals=0;
-    max_length=(1+args[0]->max_length)/2;
-  }
-};
-
-} /* namespace drizzled */
-
-#endif /* DRIZZLED_FUNCTION_STR_HEX_H */

=== modified file 'drizzled/include.am'
--- drizzled/include.am	2010-02-15 02:27:14 +0000
+++ drizzled/include.am	2010-02-15 02:54:58 +0000
@@ -144,7 +144,6 @@
 			      drizzled/function/str/elt.h \
 			      drizzled/function/str/export_set.h \
 			      drizzled/function/str/format.h \
-			      drizzled/function/str/hex.h \
 			      drizzled/function/str/insert.h \
 			      drizzled/function/str/left.h \
 			      drizzled/function/str/load_file.h \
@@ -539,7 +538,6 @@
 			   drizzled/function/str/elt.cc \
 			   drizzled/function/str/export_set.cc \
 			   drizzled/function/str/format.cc \
-			   drizzled/function/str/hex.cc \
 			   drizzled/function/str/insert.cc \
 			   drizzled/function/str/left.cc \
 			   drizzled/function/str/load_file.cc \

=== modified file 'drizzled/item/create.cc'
--- drizzled/item/create.cc	2010-02-04 08:14:46 +0000
+++ drizzled/item/create.cc	2010-02-15 02:54:58 +0000
@@ -31,7 +31,6 @@
 #include <drizzled/function/str/elt.h>
 #include <drizzled/function/str/export_set.h>
 #include <drizzled/function/str/format.h>
-#include <drizzled/function/str/hex.h>
 #include <drizzled/function/str/load_file.h>
 #include <drizzled/function/str/make_set.h>
 #include <drizzled/function/str/pad.h>
@@ -708,21 +707,6 @@
 };
 
 
-class Create_func_hex : public Create_func_arg1
-{
-public:
-  using Create_func_arg1::create;
-
-  virtual Item *create(Session *session, Item *arg1);
-
-  static Create_func_hex s_singleton;
-
-protected:
-  Create_func_hex() {}
-  virtual ~Create_func_hex() {}
-};
-
-
 class Create_func_ifnull : public Create_func_arg2
 {
 public:
@@ -1367,21 +1351,6 @@
 };
 
 
-class Create_func_unhex : public Create_func_arg1
-{
-public:
-  using Create_func_arg1::create;
-
-  virtual Item *create(Session *session, Item *arg1);
-
-  static Create_func_unhex s_singleton;
-
-protected:
-  Create_func_unhex() {}
-  virtual ~Create_func_unhex() {}
-};
-
-
 class Create_func_unix_timestamp : public Create_native_func
 {
 public:
@@ -2041,16 +2010,6 @@
   return new (session->mem_root) Item_func_max(*item_list);
 }
 
-
-Create_func_hex Create_func_hex::s_singleton;
-
-Item*
-Create_func_hex::create(Session *session, Item *arg1)
-{
-  return new (session->mem_root) Item_func_hex(arg1);
-}
-
-
 Create_func_ifnull Create_func_ifnull::s_singleton;
 
 Item*
@@ -2614,16 +2573,6 @@
   return new (session->mem_root) Item_func_ucase(arg1);
 }
 
-
-Create_func_unhex Create_func_unhex::s_singleton;
-
-Item*
-Create_func_unhex::create(Session *session, Item *arg1)
-{
-  return new (session->mem_root) Item_func_unhex(arg1);
-}
-
-
 Create_func_unix_timestamp Create_func_unix_timestamp::s_singleton;
 
 Item*
@@ -2725,7 +2674,6 @@
   { { C_STRING_WITH_LEN("FROM_DAYS") }, BUILDER(Create_func_from_days)},
   { { C_STRING_WITH_LEN("FROM_UNIXTIME") }, BUILDER(Create_func_from_unixtime)},
   { { C_STRING_WITH_LEN("GREATEST") }, BUILDER(Create_func_greatest)},
-  { { C_STRING_WITH_LEN("HEX") }, BUILDER(Create_func_hex)},
   { { C_STRING_WITH_LEN("IFNULL") }, BUILDER(Create_func_ifnull)},
   { { C_STRING_WITH_LEN("INSTR") }, BUILDER(Create_func_instr)},
   { { C_STRING_WITH_LEN("ISNULL") }, BUILDER(Create_func_isnull)},
@@ -2770,7 +2718,6 @@
   { { C_STRING_WITH_LEN("TIME_FORMAT") }, BUILDER(Create_func_time_format)},
   { { C_STRING_WITH_LEN("TO_DAYS") }, BUILDER(Create_func_to_days)},
   { { C_STRING_WITH_LEN("UCASE") }, BUILDER(Create_func_ucase)},
-  { { C_STRING_WITH_LEN("UNHEX") }, BUILDER(Create_func_unhex)},
   { { C_STRING_WITH_LEN("UNIX_TIMESTAMP") }, BUILDER(Create_func_unix_timestamp)},
   { { C_STRING_WITH_LEN("UPPER") }, BUILDER(Create_func_ucase)},
   { { C_STRING_WITH_LEN("UUID") }, BUILDER(Create_func_uuid)},

=== added directory 'plugin/hex_functions'
=== added file 'plugin/hex_functions/hex_functions.cc'
--- plugin/hex_functions/hex_functions.cc	1970-01-01 00:00:00 +0000
+++ plugin/hex_functions/hex_functions.cc	2010-02-15 02:54:58 +0000
@@ -0,0 +1,200 @@
+/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2008 Sun Microsystems
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; version 2 of the License.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#include "config.h"
+#include <drizzled/util/convert.h>
+#include "drizzled/internal/m_string.h"
+
+#include <drizzled/plugin/function.h>
+#include <drizzled/function/str/strfunc.h>
+
+using namespace drizzled;
+
+class HexFunction :public Item_str_func
+{
+  String tmp_value;
+public:
+  HexFunction() :Item_str_func() {}
+  const char *func_name() const { return "hex"; }
+  String *val_str(String *);
+  void fix_length_and_dec()
+  {
+    collation.set(default_charset());
+    decimals=0;
+    max_length=args[0]->max_length*2*collation.collation->mbmaxlen;
+  }
+
+  bool check_argument_count(int n) { return n == 1; }
+};
+
+class UnHexFunction :public Item_str_func
+{
+  String tmp_value;
+public:
+  UnHexFunction() :Item_str_func()
+  {
+    /* there can be bad hex strings */
+    maybe_null= 1;
+  }
+  const char *func_name() const { return "unhex"; }
+  String *val_str(String *);
+  void fix_length_and_dec()
+  {
+    collation.set(&my_charset_bin);
+    decimals=0;
+    max_length=(1+args[0]->max_length)/2;
+  }
+  bool check_argument_count(int n) { return n == 1; }
+};
+
+/**
+  convert a hex digit into number.
+*/
+static int hexchar_to_int(char c)
+{
+  if (c <= '9' && c >= '0')
+    return c-'0';
+  c|=32;
+  if (c <= 'f' && c >= 'a')
+    return c-'a'+10;
+  return -1;
+}
+
+String *HexFunction::val_str(String *str)
+{
+  String *res;
+  assert(fixed == 1);
+  if (args[0]->result_type() != STRING_RESULT)
+  {
+    uint64_t dec;
+    char ans[65],*ptr;
+    /* Return hex of unsigned int64_t value */
+    if (args[0]->result_type() == REAL_RESULT ||
+        args[0]->result_type() == DECIMAL_RESULT)
+    {
+      double val= args[0]->val_real();
+      if ((val <= (double) INT64_MIN) ||
+          (val >= (double) (uint64_t) UINT64_MAX))
+        dec=  ~(int64_t) 0;
+      else
+        dec= (uint64_t) (val + (val > 0 ? 0.5 : -0.5));
+    }
+    else
+      dec= (uint64_t) args[0]->val_int();
+
+    if ((null_value= args[0]->null_value))
+      return 0;
+    ptr= internal::int64_t2str(dec,ans,16);
+    if (str->copy(ans,(uint32_t) (ptr-ans),default_charset()))
+      return &my_empty_string;			// End of memory
+    return str;
+  }
+
+  /* Convert given string to a hex string, character by character */
+  res= args[0]->val_str(str);
+  if (!res || tmp_value.alloc(res->length()*2+1))
+  {
+    null_value=1;
+    return 0;
+  }
+  null_value=0;
+  tmp_value.length(res->length()*2);
+
+  (void) drizzled_string_to_hex((char*) tmp_value.ptr(), res->ptr(),
+                                res->length());
+  return &tmp_value;
+}
+
+  /** Convert given hex string to a binary string. */
+
+String *UnHexFunction::val_str(String *str)
+{
+  const char *from, *end;
+  char *to;
+  String *res;
+  uint32_t length;
+  assert(fixed == 1);
+
+  res= args[0]->val_str(str);
+  if (!res || tmp_value.alloc(length= (1+res->length())/2))
+  {
+    null_value=1;
+    return 0;
+  }
+
+  from= res->ptr();
+  null_value= 0;
+  tmp_value.length(length);
+  to= (char*) tmp_value.ptr();
+  if (res->length() % 2)
+  {
+    int hex_char;
+    *to++= hex_char= hexchar_to_int(*from++);
+    if ((null_value= (hex_char == -1)))
+      return 0;
+  }
+  for (end=res->ptr()+res->length(); from < end ; from+=2, to++)
+  {
+    int hex_char;
+    *to= (hex_char= hexchar_to_int(from[0])) << 4;
+    if ((null_value= (hex_char == -1)))
+      return 0;
+    *to|= hex_char= hexchar_to_int(from[1]);
+    if ((null_value= (hex_char == -1)))
+      return 0;
+  }
+  return &tmp_value;
+}
+
+plugin::Create_function<HexFunction> *hex_function= NULL;
+plugin::Create_function<UnHexFunction> *unhex_function= NULL;
+
+static int initialize(drizzled::plugin::Registry &registry)
+{
+  hex_function= new plugin::Create_function<HexFunction>("hex");
+  unhex_function= new plugin::Create_function<UnHexFunction>("unhex");
+  registry.add(hex_function);
+  registry.add(unhex_function);
+  return 0;
+}
+
+static int finalize(drizzled::plugin::Registry &registry)
+{
+   registry.remove(hex_function);
+   registry.remove(unhex_function);
+   delete hex_function;
+   delete unhex_function;
+   return 0;
+}
+
+DRIZZLE_DECLARE_PLUGIN
+{
+  DRIZZLE_VERSION_ID,
+  "hex_functions",
+  "1.0",
+  "Stewart Smith",
+  "Convert a string to HEX() or from UNHEX()",
+  PLUGIN_LICENSE_GPL,
+  initialize, /* Plugin Init */
+  finalize,   /* Plugin Deinit */
+  NULL,   /* status variables */
+  NULL,   /* system variables */
+  NULL    /* config options */
+}
+DRIZZLE_DECLARE_PLUGIN_END;

=== added file 'plugin/hex_functions/plugin.ini'
--- plugin/hex_functions/plugin.ini	1970-01-01 00:00:00 +0000
+++ plugin/hex_functions/plugin.ini	2010-02-15 02:54:58 +0000
@@ -0,0 +1,4 @@
+[plugin]
+title=HEX() and UNHEX() functions
+description=converting strings to and from hexadecimal
+load_by_default=yes

